from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String

Genie3_V0_1_0 = CommandToolBuilder(tool="genie3", base_command=["genie3"], inputs=[ToolInput(tag="in_arg_expression_table", input_type=Boolean(optional=True), prefix="-i", doc=InputDocumentation(doc="[ --infile ] arg                   The expression table (without headers)")), ToolInput(tag="in__arg_file_containing_gene_names", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc="[ --genes ] arg                    File containing gene names")), ToolInput(tag="in_deprecated_transform_data", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="[ --scale ]                        (deprecated) Transform data to z-scores")), ToolInput(tag="in_no_scale", input_type=Boolean(optional=True), prefix="--no-scale", doc=InputDocumentation(doc="Do not transform data to z-scores")), ToolInput(tag="in_arg_node_size", input_type=Boolean(optional=True), prefix="-N", doc=InputDocumentation(doc="[ --min-node-size ] arg (=5)       Minimum node size")), ToolInput(tag="in_arg_minimal_proportion", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="[ --min-prop ] arg (=0.1)          Minimal proportion in random forest")), ToolInput(tag="in_arg_alpha_value", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="[ --alpha ] arg (=0.5)             Alpha value for random forests")), ToolInput(tag="in_arg_number_random", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="[ --ntree ] arg (=1000)            Number of random forest trees to grow")), ToolInput(tag="in_arg_sqrtm_number", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc="[ --mtry ] arg (=sqrt(m))          Number of features to sample in each")), ToolInput(tag="in_arg_number_genes", input_type=Boolean(optional=True), prefix="-B", doc=InputDocumentation(doc="[ --batch-size ] arg (=0)          Number of genes in MPI batch")), ToolInput(tag="in_arg_directory_path", input_type=Boolean(optional=True), prefix="-T", doc=InputDocumentation(doc="[ --tempdir ] arg                  Temporary directory path")), ToolInput(tag="in_arg_number_openmp", input_type=Boolean(optional=True), prefix="-O", doc=InputDocumentation(doc="[ --threads ] arg (=2)             Number of OpenMP threads per MPI task")), ToolInput(tag="in_force_overwrite_output", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="[ --force ]                        Force overwrite if output already")), ToolInput(tag="in_arg_geniescorestsvoutput_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="[ --outfile ] arg (=genie3_scores.tsv)\nOutput file path")), ToolInput(tag="in_save_resume", input_type=File(optional=True), prefix="--save-resume", doc=InputDocumentation(doc="Path to a file that stores job resume")), ToolInput(tag="in_arg_verbosity_level", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="[ --verbosity ] arg (=3)           Verbosity level (lower is less verbose)")), ToolInput(tag="in_print_program_version", input_type=Boolean(optional=True), prefix="-V", doc=InputDocumentation(doc="[ --version ]                      Print the program version")), ToolInput(tag="in_tree", input_type=String(), position=0, doc=InputDocumentation(doc="MPI Options:")), ToolInput(tag="in_exists", input_type=String(), position=0, doc=InputDocumentation(doc="-t [ --targets ] arg                  File containing gene names of genes of ")), ToolInput(tag="in_info_dot", input_type=String(), position=0, doc=InputDocumentation(doc="--resume-from arg                     Try to resume job from this file."))], outputs=[ToolOutput(tag="out_arg_geniescorestsvoutput_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_arg_geniescorestsvoutput_file", type_hint=File()), doc=OutputDocumentation(doc="[ --outfile ] arg (=genie3_scores.tsv)\nOutput file path"))], container="quay.io/biocontainers/seidr:0.14.2--mpi_mpich_h6f92565", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Genie3_V0_1_0().translate("wdl")

